<template>
    <div class="GoatBloodLog">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">羊血登记</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getGoatBloodLogList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    ref="multipleTable"
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="id" label="序号" width="80"></el-table-column>
                    <el-table-column prop="sheepId" label="羊ID"></el-table-column>
                    <el-table-column prop="bleedingTime" label="放血时间"></el-table-column>
                    <el-table-column prop="slaughterBatch" label="屠宰批次"></el-table-column>
                    <el-table-column prop="weight" label="重量(kg)"></el-table-column>
                    <el-table-column prop="shelfLife" label="保质期(天)"></el-table-column>
                    <el-table-column prop="storageLocation" label="存放位置"></el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form
                        ref="addGoatBloodLog"
                        :model="formData"
                        :rules="rules"
                        label-width="140px"
                    >
                        <el-form-item label="羊ID">
                            <el-input v-model="formData.sheepId"></el-input>
                        </el-form-item>
                        <el-form-item label="剥离时间">
                            <el-date-picker
                                v-model="formData.bleedingTime"
                                type="date"
                                value-format="yyyy-MM-dd"
                                placeholder="选择日期"
                            ></el-date-picker>
                        </el-form-item>
                        <el-form-item label="屠宰批次">
                            <el-input v-model="formData.slaughterBatch"></el-input>
                        </el-form-item>
                        <el-form-item label="重量(kg)">
                            <el-input v-model.number="formData.weight"></el-input>
                        </el-form-item>
                        <el-form-item label="保质期">
                            <el-input v-model="formData.shelfLife"></el-input>
                        </el-form-item>
                        <el-form-item label="存放位置">
                            <el-input v-model.number="formData.storageLocation"></el-input>
                        </el-form-item>
                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addGoatBloodLog')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqGoatBloodLogList,
    reqAddGoatBloodLog,
    reqUpdateGoatBloodLog,
    reqDelGoatBloodLog
} from "@/api/productManagement.js";

const pageSize = 10;
const rules = {};

export default {
    name: "GoatBloodLog",
    data() {
        return {
            search: "",
            page: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                sheepId: "1010",
                bleedingTime: this.$moment().format("YYYY-MM-DD"),
                slaughterBatch: "1210",
                weight: 16,
                shelfLife: "365",
                storageLocation: "冷藏仓"
            },
            isAdd: false,
            rules
        };
    },
    created() {
        // 羊血登记列表
        this.getGoatBloodLogList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    if (this.isAdd) {
                        reqAddGoatBloodLog(this.formData)
                            .then(res => {
                                // 羊血登记列表
                                this.getGoatBloodLogList();
                                // this.$message.success("添加成功！");
                                if (res.errCode) {
                                    this.$message.error(res.errMsg);
                                } else {
                                    this.$message.success("成功");
                                }
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("添加失败！");
                            });
                    } else {
                        reqUpdateGoatBloodLog(this.formData)
                            .then(res => {
                                // 羊血登记列表
                                this.getGoatBloodLogList();
                                this.$message.success("编辑成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("编辑失败！");
                            });
                    }
                } else {
                    return false;
                }
            });
        },
        // 羊血登记列表
        getGoatBloodLogList() {
            reqGoatBloodLogList({
                searchStr: this.search,
                pageSize,
                pageNum: this.page
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        add() {
            this.isShow = true;
            this.isAdd = true;
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
            this.isAdd = false;
        },
        del(row) {
            reqDelGoatBloodLog(row.id)
                .then(res => {
                    console.log(res);
                    // 羊血登记列表
                    this.getGoatBloodLogList();
                    this.$message.success("删除成功！");
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        pageChange(p) {
            console.log(p);
            this.page = p;
            // 羊血登记列表
            this.getGoatBloodLogList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>